import PopContactForm from '@/components/PopContactForm'
import { PlusOutlined } from '@ant-design/icons'
// import ProTable, { TableDropdown } from '@ant-design/pro-table';
import ProTable from '@ant-design/pro-table'
// import { PageHeaderWrapper } from '@ant-design/pro-layout';
import { Button, Card, Tag } from 'antd'
import { connect } from 'dva'
import React, { useEffect, useState } from 'react'
// import styles from './customer.less';
// import request from 'umi-request';
// import { queryContact } from '@/services/contact';

const Contact = props => {
  // let tag = Array.from(tag);
  const [ visible, setVisible ] = useState(false)

  // 展示drawer
  const showDrawer = () => {
    setVisible(true)
  }

  // 隐藏drawer
  const hideDrawer = () => {
    setVisible(false)
  }

  const onCreate = values => {
    console.log(values)
  }

  const columns = [
    {
      title: '联系人',
      dataIndex: 'clientname',
      key: 'clientname',
      render: clientname => <a onClick={showDrawer}>{clientname}</a>
    },
    {
      title: '客户名称',
      dataIndex: 'companyname',
      key: 'companyname',
      render: companyname => <a>{companyname}</a>
    },
    {
      title: '部门',
      dataIndex: 'department',
      key: 'department'
    },
    {
      title: '电话',
      dataIndex: 'telephone',
      key: 'telephone'
    },
    {
      title: '手机',
      dataIndex: 'phone',
      key: 'phone'
    },
    {
      title: 'QQ',
      dataIndex: 'qq',
      key: 'qq'
    },
    {
      title: '邮箱',
      dataIndex: 'email',
      key: 'email'
    },
    {
      title: '职务',
      dataIndex: 'position',
      key: 'position'
    },
    {
      title: '办公室',
      dataIndex: 'office',
      key: 'office'
    },
    {
      title: '地区',
      dataIndex: 'local',
      key: 'local'
    },
    {
      title: '个人标签',
      dataIndex: 'tag',
      key: 'tag',
      render: (_, record) => <Tag color="#16A085">{record.tag}</Tag>,
      filters: true,
      // onFilter: true,
      valueType: 'select',
      valueEnum: {
        all: { text: '全部', status: 'Default' },
        green: {
          text: '个人标签1',
          status: 'green'
        },
        blue: {
          text: '个人标签2',
          status: 'blue'
        },
        purple: {
          text: '个人标签3',
          status: 'purple'
        },
        red: {
          text: '个人标签4',
          status: 'red'
        },
        brown: {
          text: '个人标签5',
          status: 'brown'
        },
        black: {
          text: '个人标签6',
          status: 'black'
        },
        yellow: {
          text: '个人标签7',
          status: 'yellow'
        }
      }
      // render:(_, record) => {
      //   console.log(record);
      // }
    },
    {
      title: '协作标签',
      dataIndex: 'tooltip',
      key: 'tooltip',
      render: (_, record) => <Tag color="#F8AC59">{record.tooltip}</Tag>,
      filters: true,
      valueType: 'select',
      valueEnum: {
        all: { text: '全部', status: 'Default' },
        green: {
          text: '协作标签1',
          status: 'green'
        },
        blue: {
          text: '协作标签2',
          status: 'blue'
        },
        purple: {
          text: '协作标签3',
          status: 'purple'
        },
        red: {
          text: '协作标签4',
          status: 'red'
        },
        brown: {
          text: '协作标签5',
          status: 'brown'
        },
        black: {
          text: '协作标签6',
          status: 'black'
        },
        yellow: {
          text: '协作标签7',
          status: 'yellow'
        }
      }
    },
    {
      title: '地址',
      dataIndex: 'address',
      key: 'address'
    },
    {
      title: '乘车',
      dataIndex: 'ride',
      key: 'ride'
    },
    {
      title: '地标',
      dataIndex: 'landmarks',
      key: 'landmarks'
    },
    {
      title: '住宿',
      dataIndex: 'stay',
      key: 'stay'
    },
    {
      title: '备注',
      dataIndex: 'mark',
      key: 'mark'
    },
    {
      title: '软件锁',
      dataIndex: 'keynum',
      key: 'keynum',
      render: keynum => <a>{keynum}</a>
    },
    {
      title: '大司空',
      dataIndex: 'dasikong',
      key: 'dasikong'
    },
    {
      title: '养护云',
      dataIndex: 'yanghuyun',
      key: 'yanghuyun'
    },
    {
      title: '创建人',
      dataIndex: 'chuanpeople',
      key: 'chuanpeople'
    }
  ]
  const {
    contactName: { list }
  } = props // 将contact中的pros.list命名为list
  const [ columnsStateMap, setColumnsStateMap ] = useState({
    telephone: {
      show: false
    },
    qq: {
      show: false
    },
    position: {
      show: false
    },
    office: {
      show: false
    },
    stay: {
      show: false
    },
    dasikong: {
      show: false
    },
    yanghuyun: {
      show: false
    }
  })
  useEffect(() => {
    // props.getlist();
    const initData = () => {
      const { dispatch } = props
      dispatch({
        type: 'contact/fetch'
      }) // 派发出这个action就会调用contact中的fetch函数，然后就会请求数据
    }
    initData()
  }, [ props ])

  return (
    // <PageHeaderWrapper></PageHeaderWrapper>
    <Card bordered={false}>
      <ProTable
        size="middle"
        columns={columns}
        dataSource={list}
        pagination={{ pageSize: 8 }}
        search={false}
        options={{
          search: true
        }}
        scroll={{ y: 580 }}
        columnsStateMap={columnsStateMap}
        onColumnsStateChange={map => setColumnsStateMap(map)}
        headerTitle="联系人"
        toolBarRender={() => [
          <Button key="button" icon={<PlusOutlined />} type="primary">
            联系人
          </Button>
        ]}
      />
      <PopContactForm onClose={hideDrawer} visible={visible} onCreate={onCreate} />
    </Card>
  )
}

export default connect(({ contact, loading }) => ({
  contactName: contact,
  getlist: loading.effects['contact/fetch']
}))(Contact)
